/*
  Designed by Linjianghua(Xempo) 2004-2006, 2012
  Free under LGPL
*/

#ifndef		_fsp_dir_
#define		_fsp_dir_
#include "fsplus.h"

#define	DIR_DEL			512+(1<<4)
#define	DIR_REN		512+(2<<4)
#define	DIR_WRITE		512+(3<<4)
#define	DIR_READ		512+(4<<4)

#define	DIR_RESCUE		512+(5<<4)
#define	DIR_FCU_POS		512+(7<<4)
#define	DIR_FCU_BLANK		512+(8<<4)
#define	DIR_BROW		512+(9<<4)

#define Ch_Dir			8192
#define DECT_OVER		16384

extern const char rootchs[];

extern int nameVerify(const char *dirnam); /* Case */

extern int getLenght(fsp_dir *);

extern void (*pGetPdExt)(fsp_dir *dir);

#define  pd_param_cnt  5
extern void setPdPara(fsp_dir *dir, const un_Int *pms);

extern void setZero(fsp_dir *dir, int s);

__BEGIN_DECLS

extern fsp_dir *pdParent(fsp_dir *dir, char *pth, char **fixname);

#define pdAlloc() zalloc(sizeof(fsp_dir));

extern fsp_dir *pdRead(fsp_lib *lib, DirFCU *du, dskadr_t adr);
/*  after ought to call pd_close(dir,2)  */

/*	*para=0; Format 
	para[1]=10;	n_stat_FCT   10 
	para[2]=4;	dir_stat_FCT  4 
	para[3]=dau, ignore = 1
	para[4]=1|2;  mode: RW  */
extern fsp_dir *pd_creat(fsp_dir *odir, char *pth, const un_Int *pms);

extern fsp_dir *pd_open(fsp_dir *cdir, const char *pth, int _msg);
#define	DirOpen(dir,pth)	pd_open(dir, pth, DIR_READ)

extern void pd_close(fsp_dir *dir, int mode);
__END_DECLS

#define  isSameFspDir(dir1, dir2) (dir1->Own_FCU_Addr==dir2->Own_FCU_Addr)

#endif

