/*
  Designed by Linjianghua(Xempo) 2004-2006, 2012,2014
  Free under LGPL
*/

#include "fcu.h"
#include "dirext.h"
#include "infor.h"

int del_mode, kRescue, kRedir;

fsp_dir *dst_dir;

inline BOOL IsUseDir(fsp_lib *lib, dskadr_t adr)
{
int i, B;
fsp_dir *dir;
for(i=0; i<lib->cnt_usedir; i++){
 dir=lib->usedirs[i];  B=0;
 if(isNormDir(dir)){
     _loop_: if(dir->own_adr==adr)return True;
     if(dir->parent_adr==0)continue;
     if(B)pd_close(dir, 2);
     dir=pdRead(lib,NULL,dir->parent_adr);
     B=1;
     goto _loop_;
   }
}
return False;
}

inline void Erase(fsp_dir *dir,BYTE *unit)
{
int i;
MAU send;
for(i=0;i<dir->DAUC;i++){
	send.len=*(int *)( pFcuDauPos(dir,unit,i) + sizeof(dskadr_t) );
	send.buf=(char *)zalloc(send.len);
	writeDAU(dir, unit, &send, i);
	free(send.buf);
	}
*unit=3;
}

int undelNum(fsp_dir *dir, BYTE *unit, dskadr_t pos)
{
      if(isZero(dir->Format)==False){
      	int nmb=FCU_Numb(dir,unit);
	BYTE *stat;
      	if((stat=seekFCU(dir,nmb,NULL,NUMB_BROW))!=NULL){
	char buf[102], *dscpt;
	switch(kRescue){
	case 'i' : break;
	case 'a' :  goto _skp_;
	default :	
		dscpt=GetManu(UndelNCover_26);
		free(stat);	   sprintf(buf,dscpt,dir->name,nmb);
		free(dscpt);	   kRescue=popMsg(buf,NULL, 0, fspX);
		switch(kRescue){
		case 'n' : return 2;
		case Esc : return 0;
	   	}
		_skp_:	*stat=2;
		chDirFCU(dir, stat, dir->lib->FCU_dyw, -1);
	}
	}
	}
      *unit=1;
      chDirFCU(dir,unit,pos,1);
      return 1;
}

int undelPd(fsp_dir *dir, DirFCU *du1)
{
      int pos=dir->lib->FCU_dyw;
      DirFCU *du;
      int rt=1;
      if((du=pdSeek(dir,du1->name,DIR_BROW))!=NULL){
	char buf[120], *dscpt;
	switch(kRedir){
	case 'i' : break;
	case 'a' :  goto _skp_;
	default :	dscpt=GetManu(UndelDCover_27);
		free(du);	sprintf(buf,dscpt,du1->name);
		free(dscpt);	kRedir=popMsg(buf,NULL,1, NULL);
		switch(kRedir){
		case  'n' : return 2;
		case Esc : return 0;
		}
		_skp_ : rt=pdDel(dir,du1->name,0);
	}
	}
    dir->lib->FCU_dyw=pos;
    return rt;
}

inline int numbFCU(fsp_dir *dir,BYTE *unit)
{
    int n, i, cntdir=dir->Num_FCUs_Block, unitlen=dir->Num_FCU_Len;/* protect bit flow */
    for(i=0; i<cntdir; i++,unit+=unitlen){
      if(_step<0){/* del */
	if(*unit==1){
		char buf[200];
		if( unit[1]&FSP_OEM ){
			n=OEM_20;
			goto _wrong_;
		}
		if( (unit[1]&FSP_MW)==0){
			n=NoWrite_15;
		_wrong_:	if(dir!=dst_dir){
			  char *pt=pdPathNam(dir, dst_dir, 1);
			  sprintf(buf, " %s/%ld", pt, isZero(dir->Format) ? dir->NumbForZero+i : *(int *)(unit+FCU_NumPos) );
			  free(pt);
			  }
			else sprintf(buf, " %ld", isZero(dir->Format) ? dir->NumbForZero+i : *(int *)(unit+FCU_NumPos) );
			msgShow(buf);
			idxdscpt=n;
			return 0;
		}
		if(del_mode==FSP_erase)Erase(dir,unit);
		else *unit=2;
		chDirFCU(dir,unit,dir->pos_numb_FCT+i*unitlen,-1);
	}
      }
      else if(*unit>1)undelNum(dir, unit, dir->pos_numb_FCT+i*unitlen);
    }
    if(isZero(dir->Format))dir->NumbForZero+=cntdir;
    return 1;
}

inline int pdFCU(fsp_dir *pcdir,fsp_dir *Dir)
{
  if(pcdir->mode&FSP_OEM){
    idxdscpt=OEM_20;
    goto _err_info_;
  }
  if((pcdir->mode&FSP_MW)==0){
    idxdscpt=NoWrite_15;
    _err_info_: reportBug();
    return 2;
  }

 if(_step>0){ /* dir Rescue */
      if(Dir->tag>1){
	int rt=undelPd(pcdir, (DirFCU *)(&Dir->tag) );
	if(rt!=1)return rt;
	setDirFCU(pcdir, Dir, Dir->Own_FCU_Addr, Dir->selfsize);
		}
	}
 else if(Dir->tag==1){
	if(Dir->mode&FSP_OEM){
	    idxdscpt=OEM_20;
	    goto _err_proc_;
	}
	if((Dir->mode&FSP_MW)==0){
	    idxdscpt=NoWrite_15;
	    _err_proc_: reportBug();
	    return 2;
	}
/*	setDirFCU(pcdir, Dir, Dir->Own_FCU_Addr, Dir->selfsize);*/
    return msg_Dir_Del;
  }
 return 1;
}

int FCU_pdModify(fsp_dir *pdir,DirFCU *du, int nCom)
{
  unsigned int dirsz;
  dskadr_t pos=pdir->lib->FCU_dyw;
  fsp_dir *dir2;
  int rt, msg=LoopNum|LoopDir|LoopDirSub;
  dir2=pdRead(pdir->lib, du,du->pDir);
  del_mode=nCom;
  switch(nCom){
  case FSP_ndels  : msg=LoopNum|LoopDirSub;
	break;
  case DIR_RESCUE : msg=LoopNum|LoopDir|LoopDirSub|LoopForce;
  }
  dirsz=dir2->selfsize;
  dst_dir=dir2;
  rt=DirFullBrow(dir2, msg, numbFCU, pdFCU);
  if((rt&33) /* rt==1 || rt==32 */
	&&isNormDir(dir2) ){
	if(nCom!=FSP_empty /* DirEmpty */ && nCom!=FSP_ndels)setDirFCU(pdir, dir2, pos, nCom!=DIR_RESCUE? dir2->selfsize : dirsz);
	}
  pd_close(dir2,2);
  return rt;
}

BOOL pdDel(fsp_dir *dir,char *dirnam,int nCom)
{
 BOOL rt=False;
 DirFCU *du=pdSeek(dir,dirnam,DIR_DEL);
 if(idxdscpt>0x7ffd){
   if(nCom!=FSP_empty&&nCom!=FSP_ndels&&IsUseDir(dir->lib,du->pDir))idxdscpt=UsingDir_19;
   else {
	_step=-1;
	rt=FCU_pdModify(dir, du, nCom);
	}
   free(du);
 }
 if(rt==False)reportBug();/* 因有子目录，所以要实时报错，不同numb */
 return rt;
}

int pdRen(fsp_dir *dir,char *src, const char *dst)
{
  DirFCU *unit;
  if(nameVerify(dst)==False)idxdscpt=InvName_13;
    else if((unit=pdSeek(dir,dst,DIR_FCU_POS))!=NULL){ idxdscpt=Dir_Exist9; free(unit); }
        else if((unit=pdSeek(dir,src,DIR_REN))!=NULL){
		fsp_lib *lib=dir->lib;
		dkwrite(lib,lib->FCU_dyw+namepos,dst,DirNamLen);
		if(unit->pDir==lib->CurDir->own_adr)namecpy(lib->CurDir->name,dst);
		free(unit);
		return 1;
           }
  if(idxdscpt<0x7ffd)fspHB(idxdscpt, getMsg ? 0:1);
  return 0;
}

