/*
	Write & edit by Linjianghua 2005-06,2008-2011
	Free under LGPL
*/

#include "dirloop.h"
#include "fspdir.h"

const char SPC[]="", rtl_chr[]="zt#e";
int  _step;

int BrowNumbs(fsp_dir *dir,int (*pro_numb)(fsp_dir *,BYTE *))
{
 int rt=1; // no numb is normal !
 fsp_lib *lib=dir->lib;
 if( dir->numb_FCT>0 ){
	BYTE *dsb;
	dir->NumbForZero=0;
	if(lib->sys_Id_done)lib->cur_sys_numb_FCT=lib->sys_numb_FCT;
	else dir->cur_numb_FCT=dir->numb_FCT;
	while((dsb=seekFCU(dir,0,NULL, NUMB_FCU_BLANK))!=NULL){
	   rt=pro_numb(dir,dsb);
	   free(dsb);
	   if(rt==0||dir->cur_numb_FCT<1)break;
	}
  }
 lib->sys_Id_done=False; /* only export & rebuild use it (True), so here set False*/
 return rt;
}

void setDirFCU(fsp_dir *pdir, fsp_dir *dir, dskadr_t pos, unsigned int dirsiz)
{
	BYTE flag=_step > 0 ? 1 : 2;
	fsp_lib *lib=dir->lib;
	pdir->selfdirs+=_step; pdir->mdf|=1;
	lib->tolDir+=_step; lib->mdf|=1;
	if(_step>0){
		pdir->selfsize+=dir->savelen;
		lib->useSize+=(dirsiz + dir->savelen);
		}
	else {
		pdir->selfsize-=dir->savelen;
		lib->useSize-=(dirsiz + dir->savelen);
	}
	dkwrite(lib, pos, &flag, 1);
}

/* pro_numbs or pro_dirs depend on Msg
Msg: if pro_numb null, clear 0bit. */
int DirFullBrow(fsp_dir *pdir, int Msg, int (*pro_numb)(fsp_dir *,BYTE *),int (*pro_dir)(fsp_dir *,fsp_dir *))
{
  DirFCU *unit, *dsb;
  FCU_PAT *dirloop;
  int i, rt, msg;
  fsp_dir *dir2;
  fsp_lib *lib;
  if((Msg&LoopNum)&&BrowNumbs(pdir, pro_numb)==0)return 0;
  dirloop=dGetFCU(pdir);
  if(dirloop->first_FCT==0)return 1;
  dirloop->current_FCT=dirloop->first_FCT;
  rt=1; lib=pdir->lib;
  if(Msg&(LoopDir|LoopDirSub) )
    while( (rt&33) /* rt==1 || rt==32 */
	&&(dsb=pdSeek(pdir,(void *)SPC,DIR_FCU_BLANK))!=NULL){
	unit=dsb;
	for(i=0;i<dirloop->FCU_Count&&rt;i++,unit++){
	  switch(unit->tag){
	  case 2 : if(Msg&LoopForce)goto _skp_;
		    break;
	  case 1 : if((Msg&LoopForce)==0){
	    _skp_: dir2=pdRead(lib,unit,unit->pDir);
	    if(Msg&LoopDir)rt=pro_dir(pdir,dir2);/* if rt>1, can't proc its belong */
	    if( rt&(1|msg_Dir_Del) ){ // rt==1 || rt==msg_Dir_Del
	      msg=rt;
	      if(Msg&LoopDirSub)rt=DirFullBrow(dir2,Msg,pro_numb,pro_dir);
	      if( rt && msg==msg_Dir_Del/*(Msg&2)&&pro_dir==ProcDirFCU &&step<0*/)
		setDirFCU(pdir, dir2, dir2->Own_FCU_Addr, dir2->selfsize);
	    }
	    pd_close(dir2, 2);	    
	  }
	} // end switch
	}
	free(dsb);
      }
return rt;
}

