/*
	Write by xempo(LinJiangHua)
	Free under LGPL
*/

#include "combo.h"
#include "fspcon.h"
#include "searchmodify.h"

Combo::Combo(bool w, QWidget *wdg, const char *nam) : QComboBox(w, wdg, nam)
{

}

inline bool SearchModify::fltNull()
{
return filterNull;
}

inline bool SearchModify::adjFltNull(bool b)
{
filterNull=b;
return filterNull;
}

extern int buttonMsg;

#define  comboDef  5
const char pathCombChs[]="Path", fspInpChs[]="FspInp", replCombChs[]="Replace",
	filterCombChs[]="smfilter";

const char *comboChs[comboDef]={ "dlgCombo1", "dlgCombo2", pathCombChs, 
	fspInpChs, replCombChs };

void QComboBox::returnPressed() // org is private
{
if(name()){
	int i;
	for(i=0; i<comboDef &&strcmp(name(), comboChs[i]) ; i++);
	switch(i){
	case 4 : // others is search_mdf_wdg ...
		((SearchModify *)topLevelWidget())->findStart(10 /* =1, send startMsg */);
		break;
	case 3 : ((FspCon *)topLevelWidget())->fspCom();
		break;
	case 2 : ((Filesan *)topLevelWidget())->updatePluzone(true);
		break;
	case 0 : 
	case 1 :   buttonMsg=i; topLevelWidget()->close(); // finddlg
	}
}
}

void Combo::load(FastBlock *chslst, int pix)
{
int n=chslst->count()-1;
char **lst=chslst->plist();
clear();
while(n>-1){
	if(pix>-1)insertItem(*pixmapLoad(pix), QString::fromUtf8(lst[n])); 
	else insertItem(QString::fromUtf8( lst[n]) );
	n--;
	}
}

void Combo::focusInEvent(QFocusEvent *e)
{
if(name() && strcmp(name(), filterCombChs)==0 &&
	((SearchModify *)topLevelWidget())->fltNull() )removeItem(0);
QComboBox::focusInEvent(e);
}

void Combo::focusOutEvent(QFocusEvent *e)
{
if(name() && strcmp(name(), filterCombChs)==0 &&
	((SearchModify *)topLevelWidget())->adjFltNull(lineEdit()->text().isEmpty()) ){
//	  if(text(0).isEmpty())removeItem(0);
	  insertItem(*pixmapLoad(smfilterImg), 0);
	  setCurrentItem(0);
}
QComboBox::focusOutEvent(e);
}

void Combo::comboAdd(const QString &s)
{
int i;
if(s.isEmpty())return;
for(i=0; i<count(); i++)
    if(text(i)==s){
	removeItem(i);
	break;
	}
insertItem(s, 0);
setCurrentItem(0);
}

void Combo::comboTo(FastBlock *lst)
{
int i;
for(i=count()-1; i>-1; i--)lst->add(text(i).utf8());
}

Combo *creatCombo(bool editable, QWidget *wdg, const char *nam, FastBlock *chslst, int img)
{
Combo *combo=new Combo( editable, wdg, nam);
if(chslst)combo->load( chslst, img );
// combo->lineEdit()->setAlignment( Qt::AlignTop );
return combo;
}
