/*
	Write by xempo 12-2014
	Free under LGPL
*/

#ifndef  fsp_console
#define  fsp_console

#include <qmainwindow.h>
#include "filesan.h"

class QTextBrowser;
class QAction;
class QComboBox;

class FspCon : public QMainWindow
{
moc_Object
public :
FspCon(QWidget *par);
// ~FspCon();
void exe();
void updateZone(fsp_lib *lib);
void fspCom();
void showInfo(const char *txt, const char *cap);
QTextBrowser *getBrowser() const
{ return brow; }

Combo *getInput() const
{ return input; }

void setCurLib(fsp_lib *lib){ clib=lib; }

void setEnter(bool en){ enter=en; }

protected :
bool event( QEvent *e);

private :
QTextBrowser *brow;
Filesan *filesor;
TreeView *treeview;
StatusPanel *sbar;
Combo *input;
fsp_lib *clib;
const char **_fspcon_;
int Msg;
bool enter, tableMsg;
fsp_lib *getCurLib();
QAction *infoAct, *closeCurAct;
// *setPathAct, *helpAct,
// *findAct, *fastFindAct;
QString showdata;
void addInfo(const char *txt);
};

extern FspCon *Fsp_Zone;

extern void menuPlusDo(void *);
extern int showMess(const char *txt);
extern void getMess(const char *buf);
extern void outText(int x, int attrib, const char *buf);
extern void writeCon(fsp_dir *dir, const char *txt);
extern fsp_lib *testFsp(fsp_lib *fsp);

extern const char slot_help[],  fspInp[];

#endif
