/*
	Write by LinJiangHua (xempo) 9-14 2011
	Copyright LinJiangHua (xempo)
*/

#ifndef	INFO_WIDGET
#define	INFO_WIDGET
#include <qdialog.h>

#define  NO_BTN_ID		0xfff0fff0

enum InfoWdg_Style { IW_CopyOver, IW_SureDel, IW_SymlnkObjExisted, IW_DelCvtSymToDir, IW_OverFileAsDir, IW_NormToSym,// 5
	IW_QuestContinue, IW_ErrorInfo, IW_CaseRenAll, IW_WarnOperaWrong };

// enum DialogId { OverWriteId, NumbsetErrorId, ScriptErrorId, FspPauseId }; in fsplus/source/dialogid.h

enum info_id { OverWriteId, NumbsetErrorId, ScriptErrorId, FspPauseId,
// cp
	copyOver, symlnkObjExisted, delCvtSymToDir, overFileAsDir, normToSym, questionContinue,
	copyTips, errorInfo,	noRemoveOrg,	creatSockError, mkdevError,	info_Copying, 
	normToSym4, symlnkObjExisted3, delCvtSymToDir3, copyTip2, copyOver3, dirNoExe,selCopy,
// del
	delInfo, deldirInfo, delsInfo,	noFile,
	noRightOpera,noRightWrite, notSpeFile,
// proedit 
	infoGoOnFind,infoReplace,infoAllRepl,saveForEncodec,countInfo,calcErrInfo,
	isSave,infoNoFound,tooLargeId,beMdfReloadId,
// chang
	chmodError, chownError, chtimeError, renCaseError, renCaseAll,
// other
	SearchModifyWarn, SearchCutWarn, stocksSave,
	SysCmd_reboot, SysCmd_poweroff, dirSummary,
	tarOverId, tarNoWriId, decmpOverId, decmpNoWriId
	};

#define  normError  -2

enum continueRtcl { doContinue, cancelContinue };

enum postInfoWidgetTag { CopyQuest=65005, ErrorQ=65006 };

struct infowdg_params {
const char *dst, *cap;
int info_id, hold, ret;
};

extern int btnsLen(int btnCnt, const char **btnCap, const QFont &fnt, const int *pix, bool isBtn);
extern int scalefloat(int val);
extern const QRect scaleRect(int x,int y,int w,int h);
void createBtns(QWidget *wdg, QPushButton **Btn, const char **btnCap, int btnCount,
	int wd, int yPos, const char **slot1, const int *pix);

class InfoWidget : public QDialog
{
moc_Object
public :
InfoWidget(QWidget *wdg);
int infoExe(int Id, const char *txt, const char *cap);

protected :
bool event( QEvent *);

private :
char **infowdgText;
int btnIndex,
	textLines, pixmapId,
	microCRC, color;
};

extern int  msgboxSignal; // will call in void ListContent::contentsMousePressEvent( QMouseEvent* e )

extern int infoWidget(const char *txt, const char *cap, int id, void *);
extern int popInfo(const char *txt, const char *cap, int id, void *);

extern int ErrorQuestion(QWidget *wdg, int id, const char *filenam, const char *cap=NULL );

extern void postErrInfo(QWidget *w, int num, const char *dst, const char *cap);

extern int postInfoWidget(QWidget *w, int num, const char *dst, int id, const char *cap=NULL);

#endif

